<template>
  <CabinetLayout nav-active="statistics">
    <div
      slot="block-content"
      class="statistics">
      <h1 class="title">Статистика по кликам</h1>
      <div class="subtitle">Время кликов указывается по Московскому времени (UTC +3)</div>

      <div class="line switch">
        <div class="toggle">
          <button
            type="button"
            class="item"
            :class="{ active: mode === ref.MODES.ppn }"
            @click="mode = ref.MODES.ppn">
            Новые запчасти
          </button>
          <button
            type="button"
            class="item"
            :class="{ active: mode === ref.MODES.kz }"
            @click="mode = ref.MODES.kz">
            Контрактные запчасти
          </button>
        </div>
      </div>

      <MainFilter
        :references="modeData.references"
        :loader-reference="modeData.loaderRef"
        :groups="modeData.grouping"
        :bus="modeData.bus"
        :filter-id="`stat-filter-${mode}`"
        @filter="modeData.onFilter"/>

      <div class="line actions">
        <button
          type="button"
          class="kit aqualink"
          @click="modeData.bus.$emit('resetForm')">Сбросить настройки</button>
      </div>

      <div
        class="line result"
        v-if="modeData.filterData !== null">
        <ResultTable
          key="stat-result"
          :grouping-ref="modeData.grouping"
          :filter="modeData.filterData"
          :loader="modeData.loaderData"
          :bus="modeData.bus"
          :struct="modeData.table"
          :helpers="modeData.tableHelpers"/>
      </div>
    </div>

  </CabinetLayout>
</template>

<script>
import Vue from 'vue';

import CabinetLayout from '~/components/redesign/cabinet/main-layout';
import MainFilter from '~/components/redesign/cabinet/statistics/stat-main-filter';
import ResultTable from '~/components/redesign/cabinet/statistics/result-table-clicks';

const MODES = Object.freeze({
  ppn: 0,
  kz: 1,
});

export default {
  name: 'StatClick',
  components: {
    CabinetLayout,
    MainFilter,
    ResultTable,
  },
  layout: 'cabinet',
  middleware: ({
    app: { $config: config },
    store,
    error,
  }) => {
    if (config.allStatsAllowedUserIds.includes(Number(store.state.user.auth.id))) {
      return true;
    }
    return error({ statusCode: 403 });
  },
  data() {
    return {
      mode: MODES.ppn,
      buses: {
        [MODES.ppn]: new Vue({ name: 'StatAllFilterPpnBus' }),
        [MODES.kz]: new Vue({ name: 'StatAllFilterKzBus' }),
      },
      filters: {
        [MODES.ppn]: null,
        [MODES.kz]: null,
      },
      ref: {
        MODES,
      },
    };
  },
  computed: {
    modeData() {
      const groupingDraft = {
        list: [],
        selected: [],
        loading: false,
      };
      switch (this.mode) {
        case MODES.ppn:
          return {
            loaderData: request => this.$axios.$post('/_stats/newPart/stat-all', request),
            loaderRef: (path, request) => this.$axios.$post(`/_stats/newPart/ref-all/${path}`, request),
            bus: this.buses[MODES.ppn],
            // eslint-disable-next-line vue/no-side-effects-in-computed-properties
            onFilter: (filterName) => { this.filters[MODES.ppn] = filterName; },
            filterData: this.filters[MODES.ppn],
            references: ['SHOP', 'CITY', 'BRAND', 'PART', 'USER'],
            grouping: [
              {
                value: 'PERIOD',
                text: 'Период',
                path: null,
                ...groupingDraft,
              },
              {
                value: 'SHOP',
                text: 'Магазин',
                path: 'shops',
                ...groupingDraft,
              },
              {
                value: 'CITY',
                text: 'Город',
                path: 'cities',
                ...groupingDraft,
              },
              {
                value: 'BRAND',
                text: 'Производитель товара',
                path: 'brands',
                ...groupingDraft,
              },
              {
                value: 'PART',
                text: 'Товар',
                path: 'parts',
                ...groupingDraft,
              },
              {
                value: 'USER',
                text: 'Пользователь',
                path: 'users',
                ...groupingDraft,
              },
            ],
            table: {
              col1: {
                name: 'Переходы на сайт<br>магазина по:',
                items: [
                  { key: 'clickExternalURLName', label: 'названию запчасти' },
                  { key: 'clickExternalURLOrder', label: 'кнопке "Заказать"' },
                ],
              },
              col2: {
                name: 'Внутренняя конверсия',
                items: [
                  { key: 'viewShopCard', label: 'Просмотр контактов' },
                  { key: 'sendOrder', label: 'Отправка заказов' },
                ],
              },
              col3: {
                name: 'Клики по ссылкам и кнопкам',
                items: [
                  { key: 'viewPhone', label: 'Тел.' },
                  { key: 'viewEmail', label: 'E-mail' },
                  { key: 'viewMap', label: 'Карта' },
                  { key: 'viewWebsite', label: 'Сайт' },
                  { key: 'viewMessenger', label: 'Msg' },
                  { key: 'clickChat', label: 'Чат' },
                  { key: 'clickOrder', label: '"Заказать"&nbsp;+<br>"В&nbsp;корзину"' },
                ],
              },
            },
            tableHelpers: {
              col1: 'Переходы на ваш сайт со страницы со списком предложений по названию '
                + 'запчасти и по кнопке “Заказать”',
              col2: 'Отправка заказов через gisauto.ru (“Быстрый заказ”, из “Корзины”) и просмотры '
                + 'карточки магазина',
              col3: 'Просмотр контактов в карточке магазина и клики по кнопкам “Заказать” (открытие формы'
                + '“Быстрого заказа”) и “В Корзину” (добавление товара в “Корзину”)',
            },
          };
        case MODES.kz:
          return {
            loaderData: request => this.$axios.$post('/_stats/contractPart/stat-all', request),
            loaderRef: (path, request) => this.$axios.$post(`/_stats/contractPart/ref-all/${path}`, request),
            bus: this.buses[MODES.kz],
            // eslint-disable-next-line vue/no-side-effects-in-computed-properties
            onFilter: (filterData) => { this.filters[MODES.kz] = filterData; },
            filterData: this.filters[MODES.kz],
            references: ['SHOP', 'CITY', 'USER', 'BRAND', 'MODEL', 'YEAR', 'CHASSIS', 'ENGINE', 'TITLE'],
            grouping: [
              {
                value: 'PERIOD',
                text: 'Период',
                path: null,
                ...groupingDraft,
              },
              {
                value: 'SHOP',
                text: 'Магазин',
                path: 'filials',
                ...groupingDraft,
              },
              {
                value: 'CITY',
                text: 'Город',
                path: 'cities',
                ...groupingDraft,
              },
              {
                value: 'USER',
                text: 'Пользователь',
                path: 'users',
                ...groupingDraft,
              },
              {
                value: 'BRAND',
                text: 'Марка автомобиля',
                path: 'brands',
                ...groupingDraft,
              },
              {
                value: 'MODEL',
                text: 'Модель автомобиля',
                path: 'models',
                ...groupingDraft,
              },
              {
                value: 'YEAR',
                text: 'Год выпуска',
                path: 'modelYears',
                ...groupingDraft,
              },
              {
                value: 'CHASSIS',
                text: 'Кузов',
                path: 'chassis',
                ...groupingDraft,
              },
              {
                value: 'ENGINE',
                text: 'Двигатель',
                path: 'engines',
                ...groupingDraft,
              },
              {
                value: 'TITLE',
                text: 'Заголовок объявления',
                path: 'titles',
                ...groupingDraft,
              },
            ],
            table: {
              col2: {
                name: '',
                items: [{ key: 'viewAd', label: 'Просмотр объявлений' }],
              },
              col3: {
                name: 'Клики по ссылкам и кнопкам в объявлении',
                items: [
                  { key: 'viewPhone', label: 'Тел.' },
                  { key: 'viewEmail', label: 'E-mail' },
                  { key: 'viewMap', label: 'Карта' },
                  { key: 'viewMessenger', label: 'Msg' },
                  { key: 'clickChat', label: 'Чат' },
                  { key: 'viewShopCard', label: '"Подробнее о&nbsp;магазине"' },
                ],
              },
            },
            tableHelpers: {
              col3: 'Просмотр контактов в объявлении и переходы в карточку магазина',
            },
          };
        default:
          return {};
      }
    },
  },
  created() {
  },
};
</script>

<style scoped lang="scss">
  .statistics {
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-start;
    align-items: stretch;
    width: 100%;

    .title {
      display: block;
      flex: 1 0 auto;
      margin: 0;
      padding: 1rem 1.5rem 0;
      font-size: 1.3125rem;
      font-weight: 700;
      color: #383838;
    }

    .subtitle {
      display: block;
      padding: 0.5rem 1.5rem;
      font-size: 0.8125rem;
      line-height: 1.3;
      font-weight: 400;
      color: #383838;
      @media screen and (max-width: 980px) {
        border-bottom: 1px solid #9badb9;
      }
    }

    .line.switch {
      display: block;
      padding: 0.5rem 1.5rem 0.5rem;
    }

    .line.actions {
      display: flex;
      flex: 1 0 auto;
      flex-flow: row nowrap;
      justify-content: flex-end;
      align-items: center;
      padding: 0 1.5rem 0.5rem;
      @media screen and (max-width: 980px) {
        justify-content: space-between;
        padding: 1rem 0;
      }

      > * {
        font-size: 11px;
        margin-left: 1rem;
        @media screen and (max-width: 980px) {
          font-size: 1rem;
          margin-right: 1rem;
        }
      }

    }

    .line.result {
      display: flex;
      flex-flow: column nowrap;
      height: 100%;
      overflow-x: auto;
    }

    .label {
      display: block;
      white-space: nowrap;
      font-weight: 500;
      color: #272727;
      font-size: 14px;
    }

  }

  .toggle {
    display: flex;
    flex-flow: row nowrap;
    justify-content: flex-start;
    align-items: center;
    width: auto;

    > .item {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      width: auto;
      min-width: 5.375rem;
      height: 2rem;
      padding: .5rem 1rem;
      margin-right: -1px;
      font-size: 0.8125rem;
      line-height: 1;
      font-weight: 400;
      white-space: nowrap;
      color: #272727;
      background-color: #ededed;
      border: 1px solid #9badb9;
      border-radius: 0;

      text-shadow: none;
      outline: none;
      box-shadow: none;

      &[disabled] {
        opacity: 0.7;
      }
      &:not([disabled]) {
        cursor: pointer;
        &:hover, &:focus, &:active {
          background-color: #e5eaf5;
        }
      }

      &.active {
        background-color: #fff;
        cursor: default;
        pointer-events: none;
      }

      &:last-child {
        border-top-right-radius: 0.1875rem;
        border-bottom-right-radius: 0.1875rem;
      }

      &:first-child {
        border-top-left-radius: 0.1875rem;
        border-bottom-left-radius: 0.1875rem;
      }
    }

    @media screen and (max-width: 980px) {
      flex-flow: row wrap;
      justify-content: space-between;
      > .item {
        height: 3rem;
        font-size: 1rem;
        flex: 1 0 auto;
        margin-bottom: -1px;
      }
    }
  }

</style>
